/*
NAME:       servidor
SYNOPSIS:    servidor  Port_number
*/

#include <stdio.h>
#include <errno.h>
#include <sys/time.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>

#include <pthread.h>

#include <stdlib.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>
#include <strings.h>
#include <string.h>



#define MAXHOSTNAME 80
void reusePort(int sock);   

struct Num_mesa{                //estructura para el almacenamiento de los pedidos
  char comida[20];
  char bebida[15];
  char postre[20];
  struct Num_mesa *siguiente;
};
struct Num_mesa *mesa_ini[4],*mesa_fin[4];



int mesa[8];
int port_mes[4];    // numero de puerto de los meseros
int pedido_mesa[8];


// funcion que agrega el pedido 
void agrega_pedido(int psd, int num){
  char buf[512];
  int rc,i;
  struct Num_mesa *nuevo;

     nuevo = (struct Num_mesa *) malloc (sizeof(struct Num_mesa));
     nuevo->siguiente = NULL;

     if (mesa_ini[num]==NULL) {

         mesa_ini[num] = nuevo;

         mesa_fin[num] = nuevo;

         }
      else {
           // el que hasta ahora era el último tiene que apuntar al nuevo 
           
           mesa_fin[num]->siguiente = nuevo;          //hacemos que el nuevo sea ahora el último
           mesa_fin[num] = nuevo;

      }

//// aqui va el acceso a la info y guardado en la estructura
     rc=read(psd, buf, sizeof(buf));
     buf[rc]='\0';
     for(i=0;i<=rc;i++){
     mesa_fin[num]->comida[i]=buf[i];
     }
             send(psd, buf, rc, 0);               
     rc=read(psd, buf, sizeof(buf));
     buf[rc]='\0';
     for(i=0;i<=rc;i++){
     mesa_fin[num]->bebida[i]=buf[i];
     }
             send(psd, buf, rc, 0);               
     rc=read(psd, buf, sizeof(buf));
     buf[rc]='\0';
     for(i=0;i<=rc;i++){
     mesa_fin[num]->postre[i]=buf[i];
     }
             send(psd, buf, rc, 0);               

   pedido_mesa[num]=1;


printf("\nNuevo pedido entrante\n");


}

//funcion que imprime los pedidos por mesa
void imprime(int num){
  struct Num_mesa *actual;
  actual=mesa_ini[num];
  printf("Mesa %d\n",num);
  while(actual!=NULL){
       printf("%s %s %s\n",actual->comida, actual->bebida, actual->postre);
       actual=actual->siguiente;
       }


}




////funcion que maneja el prompt de pedidos cocina
void *menu(void *args){
int k,aux=0;
  char servir[6]="servir";
    while(1){
     int condicion=0;
     printf("\n1)entregar \n2)mostrar \n3)pagar mesa");
     scanf("%d",&condicion);
     if(condicion==1){
       for (k=0;k<=7;k++){
           if(pedido_mesa[k]>0){
             imprime(k);
             }
           }

       printf("servir mesa\n");
       scanf("%d",&aux);
       send(port_mes[aux],servir,6,0);


       }
     if(condicion==2){
       printf("mostrar pedidos\n");
       for (k=0;k<=7;k++){
           if(pedido_mesa[k]>0){
             imprime(k);
             }
           }

       }
     if(condicion==3){
              for (k=0;k<=7;k++){
           if(pedido_mesa[k]>0){
             imprime(k);
             }
           }
       printf("Pagar mesa");
       scanf("%d",&aux);
       pedido_mesa[aux]=0;
       mesa_ini[aux]=NULL;
      }

     }

}





main( argc, argv )
int argc;
char *argv[];
{
  int   s, ss;
  struct   sockaddr_in server;
  struct sockaddr_in from;
  pthread_t prompt;                   // Hebra para control del prompt de cocina.
  int args[2];
  int fromlen;
  int length;

  fd_set readfds, readfdsCopy;
  int n,i;
  int sockList[64], lastSock=0;
  
// asignacion de mesas a los meseros
  mesa[0]=1;
  mesa[1]=1;
  mesa[2]=2;
  mesa[3]=2;
  mesa[4]=3;
  mesa[5]=3;
  mesa[6]=4;
  mesa[7]=4;




  /* Construct name of socket to send to. */
  server.sin_family = AF_INET;
  server.sin_addr.s_addr = htonl(INADDR_ANY);
  if (argc == 2)
      server.sin_port = htons(atoi(argv[1])); 
  else
      server.sin_port = htons(0);  

  s = socket (AF_INET,SOCK_STREAM,0); 
  reusePort(s);

  if ( bind( s, (struct sockaddr *)&server, sizeof(server) ) ) {
    close(s);
    perror("binding name to stream socket");
    exit(-1);
  }

  length = sizeof(server);
  if ( getsockname (s, (struct sockaddr *)&server,&length) ) {
    perror("getting socket name");
    exit(0);
  }

  printf("Server Port is: %d\n", ntohs(server.sin_port));

  listen(s,4);
  fromlen = sizeof(from);
  FD_ZERO(&readfdsCopy);
  FD_SET(s,&readfdsCopy);
  
  if(pthread_create(&prompt, NULL, menu,(void *) args))        // Crea la hebra que controlara el bufer de subida.
        {perror("pthread_create failed"); exit(-1);}
  
  
  for(;;){
    memcpy(&readfds, &readfdsCopy, sizeof(fd_set));
    n = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL);
    if (n > 0) {
      if (FD_ISSET(s, &readfds)) {
 
        sockList[lastSock++] = accept(s, (struct sockaddr *)&from, &fromlen);
        FD_SET(sockList[lastSock-1], &readfdsCopy);
      }
      for (i=0; i < lastSock; i++) {
        if (FD_ISSET(sockList[i], &readfds))
          if (EchoServe(sockList[i]) < 0) {
            FD_CLR(sockList[i], &readfdsCopy);
            close (sockList[i]);
            sockList[i] = sockList[--lastSock];
            i--;
            printf("Number of current clients: %d\n", lastSock);
          }
      }
    }
  }
}
int EchoServe(int psd)
{
  char buf[512];
  int rc;
  int num_mes;
  int numer_mesa;
  char pedido[6]="pedido";
  char mesero[6]="mesero";
  char llamar[6]="llamar";

  /*      get data from  clients and send it back */
  for(;;){

 
    if( (rc=read(psd, buf, sizeof(buf))) < 0)
      perror("receiving stream  message");
    if (rc > 0){
      buf[rc]='\0'; 
      if(!strncmp(mesero,buf,6)){
       // reconoce que es un mesero
        send(psd, buf, rc, 0);              
        rc=read(psd, buf, sizeof(buf));        // recibe la siguiente linea
        num_mes=atoi(buf);                 // convierte el numero char en int
        port_mes[num_mes]=psd;             //asigna a la lista de meseros el puerto de conexion

        }


          buf[rc]='\0';
      if(!strncmp(pedido,buf,6)){

         send(psd, buf, rc, 0);            
         rc=read(psd, buf, sizeof(buf));
         numer_mesa=atoi(buf);                 // convierte el numero char en int
         send(psd, buf, rc, 0);             
         
         agrega_pedido(psd,numer_mesa);
        }

       buf[rc]='\0';              //termina el string recibido
 
      if(!strncmp(llamar,buf,6)){
    
         send(psd, buf, rc, 0);             
        rc=read(psd, buf, sizeof(buf));
        numer_mesa=atoi(buf);                 // convierte el numero char en int
        send(psd, buf, rc, 0);           
        
        send(port_mes[numer_mesa],llamar,6,0);
        
        
        }



      
     
      if (send(psd, buf, rc, 0) <0 )
        perror("sending stream message");
      return(1);
    }
    else {
      printf("Disconnected..\n");
      return(-1);
    }
  }
}
void reusePort(int s)
{
  int one=1;

  if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 )
  {
    printf("error in setsockopt,SO_REUSEPORT \n");
    exit(-1);
  }
}      
